TEMPLATE = app

QT += core gui widgets
CONFIG += c++20 warn_on

SOURCES += \
	../src/gui/main.cpp \
	../src/gui/mainwindow.cpp \
	../src/utils.cpp

HEADERS += \
	ui_mainwindow.h \
	../src/gui/mainwindow.h \
	../src/utils.h

FORMS += \
	../src/gui/mainwindow.ui

DEFINES *= QT_USE_QSTRINGBUILDER		#converts + to % when building strings

# opencv
CONFIG += link_pkgconfig
PKGCONFIG += opencv4

# Vimba
INCLUDEPATH += ../vimbax/api/include
VIMBA_LIB_DIR = ../lib
LIBS += -L$${VIMBA_LIB_DIR} -lVmbC -lVmbCPP -Wl,-rpath,\'\$$ORIGIN\'

#-Wl,-rpath,.
QMAKE_POST_LINK += cp $${VIMBA_LIB_DIR}/lib*.so ../bin  # copy vmb-libs to bin

#PRE_LINK: cp vimba libs once
# cp ../b/vimbax/api/lib/GenICam/*.so $${VIMBA_LIB_DIR}
# cp ../b/vimbax/api/lib/libVmb{C,CPP,ImageTransform}.so $${VIMBA_LIB_DIR}

TARGET = recorder-gui
DESTDIR = ../bin

QMAKE_CLEAN += .cache/clangd/index/* .qmake.stash
#cant rm dir here, so added cmd in sublime project file



#####################
# see:
# 	https://doc.qt.io/qt-6/qmake-variable-reference.html
#		https://doc.qt.io/qt-6/qmake-advanced-usage.html#installing-files
#
# target.path = /opt/$${TARGET}/bin
# INSTALLS += target
#
# HEADERS += $$files("../../src/utils/*.h", true)
#
# RESOURCES = application.qrc
#
##### VARS IN QMAKE ###
#    VAR = foobar => Assign value to variable when qmake is run
#    $$VAR => QMake variable's value at the time qmake is run
#    $${VAR} => QMake variable's value at the time qmake is run (identical but enclosed to separate from surrounding text)
#    $(VAR) => Contents of an Environment variable at the time Makefile (not qmake) is run
#    $$(VAR) => Contents of an Environment variable at the time qmake (not Makefile) is run

###############################
## use "bear" to intercept compiler-calls from build-system
# > creates a jsonconfig which can be fed for clangd-configuration
#	api bear
#	bear -- make -j8
# > creates compile_commands.json
# clangd should find it on cur dir or parent dir of src file, if not set
# "clangd.compile-commands-dir": null,

# use CMake build-system to export compiler-calls:
#	CMake creates compilation database out of the box. You don't need to use Bear for that. Just pass 	-DCMAKE_EXPORT_COMPILE_COMMANDS=ON flag when you call cmake.

